#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_constant_logger4xi.py">
#<abstract4xi abstract = "tests constant_logger4xi"/>
#<verify4xi verification = "10" target = "constant_logger4xi.py"/>
#<contextualize4xi context = "__init__.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API 
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_constant_logger4xi',
            'print_trace4xi',
            'set_trace4xi'] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

#0
from constant_logger4xi import ConstantLogger4Xi

from constant_logger4xi import init_notset4xi
from constant_logger4xi import set_notset4xi
from constant_logger4xi import get_notset4xi
#1
from constant_logger4xi import init_subdebug4xi
from constant_logger4xi import set_subdebug4xi
from constant_logger4xi import get_subdebug4xi
#2
from constant_logger4xi import init_debug4xi
from constant_logger4xi import set_debug4xi
from constant_logger4xi import get_debug4xi
#3
from constant_logger4xi import init_subwarning4xi
from constant_logger4xi import set_subwarning4xi
from constant_logger4xi import get_subwarning4xi
#4
from constant_logger4xi import init_info4xi
from constant_logger4xi import set_info4xi
from constant_logger4xi import get_info4xi
#5
from constant_logger4xi import init_logger_name4xi
from constant_logger4xi import set_logger_name4xi
from constant_logger4xi import get_logger_name4xi
#6
from constant_logger4xi import init_subwarning4xi
from constant_logger4xi import set_subwarning4xi
from constant_logger4xi import get_subwarning4xi
#7
from constant_logger4xi import init_default_logging_format_logger4xi
from constant_logger4xi import set_default_logging_format_logger4xi
from constant_logger4xi import get_default_logging_format_logger4xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'ConstantLogger4Xi': 'NACK4TRACE',
         'init_notset4xi': 'NACK4TRACE',
         'set_notset4xi': 'NACK4TRACE',
         'get_notset4xi': 'NACK4TRACE',
         'init_subdebug4xi': 'NACK4TRACE',
         'set_subdebug4xi': 'NACK4TRACE',
         'get_subdebug4xi': 'NACK4TRACE',
         'init_debug4xi': 'NACK4TRACE',
         'set_debug4xi': 'NACK4TRACE',
         'get_debug4xi': 'NACK4TRACE',
         'init_subwarning4xi': 'NACK4TRACE',
         'set_subwarning4xi': 'NACK4TRACE',
         'get_subwarning4xi': 'NACK4TRACE',
         'init_info4xi': 'NACK4TRACE',
         'set_info4xi': 'NACK4TRACE',
         'get_info4xi': 'NACK4TRACE',
                                         
         'init_logger_name4xi': 'NACK4TRACE',
         'set_logger_name4xi': 'NACK4TRACE',
         'get_logger_name4xi': 'NACK4TRACE',
         'init_subwarning4xi': 'NACK4TRACE',
         'set_subwarning4xi': 'NACK4TRACE',
         'get_subwarning4xi': 'NACK4TRACE',
                        
         'init_default_logging_format_logger4xi': 'NACK4TRACE',
         'set_default_logging_format_logger4xi': 'NACK4TRACE', 
         'get_default_logging_format_logger4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
     
#</function4xi>           
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   XML trace of testing constant_logger4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-constant-logger4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing constants in system.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Constants sensed in system.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-constant-logger4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for constants in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-constant-logger4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for constants in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of system constant.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-constant-logger4xi" usage = "
#   testing constant_logger4xi 
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_constant_logger4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A1/33) OF TEST_CONSTANT_CONNECTION4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
        
   
        # ---------------------------------------------------------------------------------------------
        # PHASE I: get values without initialize                         
        # ---------------------------------------------------------------------------------------------
        print('~' *33)
        print("PHASE I: get values without initialize")
        time2xi = time4xi()
        print(time2xi)   
        print("skipped PHASE I")
    
    
         
        # ---------------------------------------------------------------------------------------------
        # PHASE II: INITIALIZE with functions                             
        # ---------------------------------------------------------------------------------------------
        print('~' *33)
        print("PHASE II: INITIALIZE with init functions") 
        time2xi = time4xi()
        print(time2xi)
        print("skipped PHASE II")
    
    
        # ---------------------------------------------------------------------------------------------
        # PHASE III: INITIALIZE All with functions                             
        # ---------------------------------------------------------------------------------------------
        print('~' *33)
        print("PHASE III: INITIALIZE All with init functions") 
        time2xi = time4xi()
        print("skipped PHASE III")
    
        
           
        # ---------------------------------------------------------------------------------------------
        # PHASE IV: SET each with a set function                             
        # ---------------------------------------------------------------------------------------------
        print('~' *33)
        print("PHASE IV: SET each with a set function")
        
        time2xi = time4xi()
        print("skipped PHASE IV")
    
    
        # =============================================================================================
        # PHASE V: use class                              
        # =============================================================================================
        print('~' *33)
        print("PHASE V: CLASS methods are being used") 
        time2xi = time4xi()
        print(time2xi)
        
        # ---------------------------------------------------------------------------------------------
        cl2xi = ConstantLogger4Xi()
        print("PHASE V: created cl2xi object of ConstantLogger4Xi class")
        
        # ---------------------------------------------------------------------------------------------
    
        print("PHASE V: call cl2xi object of ConstantLogger4Xi get methods")
         
        print('get_notset results: ', cl2xi.get_notset())
        print('get_subdebug results: ', cl2xi.get_subdebug())
        print('get_debug results: ', cl2xi.get_debug())
        print('get_info results: ', cl2xi.get_info())
        print('get_subwarning results: ', cl2xi.get_subwarning())
        print('get_logger_name results: ', cl2xi.get_logger_name())
        print('get_default_logging_format_logger results: ', cl2xi.get_default_logging_format_logger())
        
        
        print("PHASE V: get with all methods done after object initialized!")
        
     
       
        # ---------------------------------------------------------------------------------------------
        # PHASE VI: SET and GET ALL by using class objects set_all and get_all methods                              
        # ---------------------------------------------------------------------------------------------
        print("PHASE V: call cl2xi object of ConstantLogger4Xi set methods")
        
        cl2xi.set_notset(1000)
        cl2xi.set_subdebug(5000)
        cl2xi.set_debug(10000)
        cl2xi.set_info(20000)
        cl2xi.set_subwarning(25000)
        cl2xi.set_logger_name('new_logger multiprocessing4xi')
        cl2xi.set_default_logging_format_logger('[%(levelname)s/%(processName)s] %(message)s]')
    
        print("PHASE VI: call cl2xi object of ConstantLogger4Xi get methods")
     
        print('get_notset results: ', cl2xi.get_notset())
        print('get_subdebug results: ', cl2xi.get_subdebug())
        print('get_debug results: ', cl2xi.get_debug())
        print('get_info results: ', cl2xi.get_info())
        print('get_subwarning results: ', cl2xi.get_subwarning())
        print('get_logger_name results: ', cl2xi.get_logger_name())
        print('get_default_logging_format_logger results: ', cl2xi.get_default_logging_format_logger())
            
        
        print("PHASE VI: both set and get with all methods done!")
            
        # ---------------------------------------------------------------------------------------------
        # PHASE VII: INIT and GET all                              
        # ---------------------------------------------------------------------------------------------
        print("PHASE VII: call cl2xi object of ConstantLogger4Xi init methods")
            
        cl2xi.init_notset(2000)
        cl2xi.init_subdebug(10000)
        cl2xi.init_debug(20000)
        cl2xi.init_info(40000)
        cl2xi.init_subwarning(50000)
        cl2xi.init_logger_name('new_logger multiprocessing4xi')
        cl2xi.init_default_logging_format_logger('[%(levelname)s/%(processName)s] %(message)s]')
    
        print("PHASE VII: call cl2xi object of ConstantLogger4Xi get methods")
            
        print('get_notset results: ', cl2xi.get_notset())
        print('get_subdebug results: ', cl2xi.get_subdebug())
        print('get_debug results: ', cl2xi.get_debug())
        print('get_info results: ', cl2xi.get_info())
        print('get_subwarning results: ', cl2xi.get_subwarning())
        print('get_logger_name results: ', cl2xi.get_logger_name())
        print('get_default_logging_format_logger results: ', cl2xi.get_default_logging_format_logger())
            
        print("PHASE VII: both init and get with all methods done!")
    
    
        # ---------------------------------------------------------------------------------------------
        # SENSE                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('SENSE')
        print('=' *33)      
        
        cl2xi.sense()
        
        # ---------------------------------------------------------------------------------------------
        # REASON                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('REASON')
        print('=' *33)       
        cl2xi.reason()
        
        # ---------------------------------------------------------------------------------------------
        # ACE                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('ACE')
        print('=' *33)       
        cl2xi.ace()  

        # ---------------------------------------------------------------------------------------------
        # END OF TESTS                             
        # ---------------------------------------------------------------------------------------------                    
        print('~' *33)
        print("ALL TESTS COMPLETED")
        time2xi = time4xi()
        print(time2xi)
        
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
                   
#</function4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function to test constant_logger4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("SENSING IT WITH YOURDRAGONXI!")  
    print('=' *33)
        
    test_constant_logger4xi() 
    
    print('=' *33)
    print("SENSED IT WITH YOURDRAGONXI!")    
    print('=' *33) 
            
#</function4xi>
        
# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_constant_logger4xi.txt
#   sense-test-constant-logger4xi.xml
#   reason-test-constant-logger4xi.xml
#   ace-test-constant-logger4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_constant_logger4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
    